// Demo.ino 180214   13924b 1180v
// ref Affiche 0 et compte si on intervient dans les 2 sec
// Version EduC  PousG augmente, PousD diminue satu 0-9 affiche
#include "EduC.h"
#include "Oled.h"
byte sPD=0;
void setup () { if (PousD) sPD=1;  SetupEduC();   SetupOled(); }

 byte taHisto[128]; // test 11
byte nPous,cn;
void loop () {
   LiCol(0,0); Sprite (smile); LiCol(0,112); Sprite (sad); 
   LiCol(3,5); BigText("EduC - Demo");
   LiCol(5,0); Text("Poussoir gauche");
   LiCol(6,0); Text("PousD ou délai->start");
   LiCol(7,0); Text("PousD-Reset reprend");
   if (!sPD) { nPous = GetPous(); WriteEE(0,nPous);}
   else { nPous=ReadEE(0); Digit(nPous); }
   Clear(); Leds(0xFF); HpOff;  
  switch (nPous) {
    case 0:  // avec test initial leds 
     LedGOn; LedDOn; BlancOn; Leds(0xFF);
     for (byte i=0; i<150 ; i++) { HpToggle; DelMs(1);}
     for (byte i=0; i<150 ; i++) { HpToggle; DelMs(2);}
     LedGOff; LedDOff; BlancOff; Leds(0x00); HpOff;
     while ((PousG||PousD)) {LiCol(4,00); BigDec8 (GetPotG());
       BigDec8 (GetPotD()); BigDec8 (GetTemp());
     }
     Clear(); // Test 0 selon doc
     LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 0"); 
      LiCol(3,10); Text("Press PG, PD, or both");
      cn=0;
      while(1){
        if(PousG) {LedGOn;LedDOff; cn++;}
        if(PousD) {LedDOn;LedGOff; cn--;}
          LiCol(6,20); BigBin8 (cn); Leds(cn);
          DelMs(100);  // ralentir le comptage 
      }
    case 1:
      byte potG,potD;
      LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 1"); 
      LiCol(1,20); Text("Entrees analogiques"); HpOn;
      while(1) {
         if(PousG) {RougeOn;}if(!PousG) {RougeOff;}
         if(PousD) {BleuOn;}if(!PousD) {BleuOff;}
         potG = GetPotG(); potD = GetPotD();
         LiCol(4,25); BigHex8 (potG);  BigHex8 (potD);
         LiCol(7,30); BigDec8 (potG);  BigDec8 (potD);
         if (potG>0x40) {LedGOn;}  else  {LedGOff;} 
         if (potG> 187) {LedDOn;}  else  {LedDOff;}  
         Leds (~potD); 
        DelMs (20);
      }
    case 2:
      LiCol(0,0); Sprite (smile);  LiCol(0,80); Text ("Demo 2");
      LiCol(2,20); Text("Rouge+vert analogiques"); HpOff;
      LiCol(3,20); Text("PD et seccouez pour voir le PWM")
      while(1) {
         potG = GetPotG(); potD = GetPotD();
         Rouge (potG/8); Vert (potD/8);
         if (!PousG) {
            LiCol(6,25); BigDec8 (potG);  
            LiCol(6,65); BigDec8 (potD);       
            DelMs (100);
         }
         else {Clear();}
      }
    case 3:
      //byte x=0,y;
      LiCol(0,0); Sprite (smile);  LiCol(0,80); Text ("Demo 3");
      LiCol(2,20); Text("Graphique et PWM");
      Leds (0xff); HpOff;
      while(1) {
         potG = GetPotG(); potD = GetPotD();
         LiCol(0,30); Dec8 (potG); Dec8 (potD);     
         Bleu (potG/8); Vert (potD/8);
         Dot (x,63-potG/4); DDot (x,63-potD/4); 
         if (x++>=128)  {x=0; Clear(); }
         DelMs (20);
      }
    case 4:  // dessin xy
      LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 4"); 
      LiCol(2,10); Text("Dessin en x-y PG efface"); HpOff;
      while(1) {
        potG = GetPotG(); potD = GetPotD();
        LiCol(0,30); Dec8(potG/4); Dec8(potD/4);
        Dot (potG/2,63-(potD/4));
        if(PousG) {Clear();}
      }
    case 5:   // test trajectoire 
    Hline(0);
     LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 5");
     LiCol(2,10); Text("Rebonds PousD->bouge"); 
      Hline(63);  Vline(0); Vline(127);
      PosDir (64,32,3,4); HpOff;
      y1=64;y2=64;
      while(1) { Step(); D;
        if (touch&1) dy=-dy;
        if (touch&2) dx=-dx;
        if (touch&4) dy=-dy;
        if (touch&8) dx=-dx;
        while (!PousG) ; 
      } 
    case 6:   // raqette
      LiCol(0,4); Sprite (smile); LiCol(0,80); Text ("Demo 6"); 
      LiCol(0,4); Text("Pots G D ->Bouge");
      byte pot; int pos;
      PosDir(40,30,1,4); 
      while (1) {
        pot = GetPotG();  // pos 56 à 8 excursion 48 = 3/16 de 256
        pos = ((256-pot)*3)/16;
        Raq (0, pos);
        pot = GetPotD();  // pos 56 à 8 excursion 48 = 3/16 de 256
        pos = ((256-pot)*3)/16;
        Raq (127, pos);
      }
    case 7:  // Reflexe
      LiCol(0,0); Sprite (smile); LiCol(0,40); Text ("Reflexe  Demo 7"); 
      LiCol(2,0); Text("Si LG->PG si LD->PD"); HpOff;
      int cnt; byte  gd, ok;
      #define Temps 50  // temps réaction max en centième
      while(1) {
        DelMs (1000); //(random(500));
        if (random(10)<5) {gd=0; LedGOn;} else {gd=1; LedDOn;}
        cnt = 0;
        while (cnt++ < Temps) { 
          DelMs (10);
          if (PousG&&(gd==0)) {ok=1; break;}
          if (PousG&&(gd==1)) {ok=0; break;}    
          if (PousD&&(gd==0)) {ok=0; break;}
          if (PousD&&(gd==1)) {ok=1; break;}
        }       
        LedGOff; LedDOff;
        if (cnt < Temps) {  // répondu dans le délai
          if (ok==1) {LiCol(6,0); BigText("Ok   ");} // continue à jouer
          if (ok==0) {LiCol(6,0); BigText("Humm!"); RougeOn; DelMs (1000); RougeOff; }
        } else {LiCol(6,0); BigText("Lent!");        // trop lent
          BleuOn; DelMs (1000); BleuOff;    
        } 
      }  // end while(1)
      
     case 8:  // Musique
      LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 8"); 
      LiCol(2,10); Text("Au clair de la lune");
      #define D 500
      #define S DelMs(500)
      #define FaN  S; tone(14,524,D)  // noire
      #define FaR  S; tone(14,524,4*D)  // ronde
      #define SolN S; tone(14,588,D)
      #define SolB S; tone(14,588,2*D) // blanche
      #define LaN  S; tone(14,660,D)
      #define LaB  S; tone(14,660,2*D)
      while(1) { 
        BlancOn;
        FaN; FaN; FaN; SolN; LaB; SolB; 
        noTone(14); S; FaN; LaN; SolN; SolN; FaR;
        BlancOff;
        while (!PousG) ;  // on recommence?
      }
 
    case 9:  // Température
      LiCol(0,0); Sprite (smile); LiCol(0,80); Text ("Demo 9"); 
      LiCol(1,16);  Text ("Test Tmp100");
      byte temp; Leds(0xff); HpOff;
      while(1) {
        temp = GetTemp();
        LiCol(7,0); BigHex8(temp); Big('='); Big(' '); BigDec8(temp);
        y= (temp)/4;
        DotF (x,63-y); x++; if(x==128) { Clear(); x=0; }
        DelMs (300);
      }
    case 10:  // Autre Reflexe
      LiCol(0,0); Sprite (smile); LiCol(0,30); Text ("Reflexe   Demo A"); 
      LiCol(2,20); Text("Pulse vert, delai aleat");
      LiCol(3,20); Text("Blanc -> PG "); 
      LiCol(4,0); Text("Affiche delai si < 250ms"); 
      LiCol(7,38); Text("Temps nKO"); 
      int cont; byte ratt; // compte les centièmes de seconde  max 46
      ratt=0; Leds(0xff); HpOff;
    while(1) {     
      DelMs(1000); VertOn; DelMs(100); VertOff;  
      DelMs(random(300,2000));
      LedGOn; cont=0;
      while (!PousG) { DelMs(10); cont++; 
         if (cont>25) {ratt++; cont=0; break;} 
      }
      LedGOff;
      LiCol(7,0); BigDec8(cont*10); LiCol(7,90);BigDec8(ratt); 
    } 
  
    case 11:   // 0xb  Tirage au hasard 
    //byte taHisto[128]; a définir avant loop();
      byte mesure,yy;
      randomSeed(GetPotG());
      while(1) { 
        mesure = random (0,127+1);
        yy = ++taHisto[mesure];
        Dot(mesure,63-yy);
        if (yy==63) {while(1);} //fini
      }  
    case 12: // Montagnard
      #define Gpot (GetPotG()/4)
      int dl;  // on augmentera la vitesse, a 5 on recommence
      dl = 50;
      #define Del DelMs(dl); LiCol(1,0);BigDec16(tot);
      int tot; // total des mauvais points
      #define Repete(x) for(byte i=0;i<x;i++)
      #define Stop() while(1);
      #define Attend(x) while(!x);
      while(1) {
        Clear();  x=0; y=0; 
        Repete (10) {Dot (x++,63-0);}        // plateau
        Repete (40) {Dot(x++,63-y++);}       // 45 degrés
        Repete (10) {Dot(x++,63-y);}         // plateau
        Repete (20) {Dot(x++,63-y); if(x%2){y--;}  }  // petite descente
        Repete (5)  {Dot(x++,63-y);}         // plateau
        Repete (10) {Dot(x++,63-y); y+=3;}   // montée raide
        Repete (33) {Dot(x++,63-y--);}       // -45 degrés
      // total 127 (on est parti de zéro)
      // Attention départ
        LiCol(3,0);BigDec8(dl);
        Digit(3);DelMs(1000);Digit(2);DelMs(1000);Digit(1);DelMs(1000);Digit(0);
        x=0; y=0; tot=0;
        Repete (10) {Dot(x++,63-y);   DDot(x,63-Gpot); tot += abs((Gpot)-y); Del;}  
        Repete (40) {Dot(x++,63-y++); DDot(x,63-Gpot); tot += abs((Gpot)-y); Del;}   
        Repete (10) {Dot(x++,63-y);   DDot(x,63-Gpot); tot += abs((Gpot)-y); Del;}       
        Repete (20) {Dot(x++,63-y);   DDot(x,63-Gpot); if(x%2){y--;} tot += abs((Gpot)-y); Del;}  
        Repete (5)  {Dot(x++,63-y);   DDot(x,63-Gpot); tot += abs((Gpot)-y); Del;}        
        Repete (10) {Dot(x++,63-y);   DDot(x,63-Gpot); y+=3; tot += abs((Gpot)-y); Del;} 
        Repete (33) {Dot(x++,63-y--); DDot(x,63-Gpot); tot += abs((Gpot)-y); Del;}    
        dl -=5; if(dl==0) dl=50;
        Attend(PousG);
     } 

    case 13: 
      byte x13,y13;
      LiCol(2,20); Text("Toucher la balle"); 
      randomSeed(GetPotG());
      while(1) { 
        x= random(2,120); y= random(2,54); Ball(x,y);
        while((abs(x13-x-3)>2)||(abs(y13-y-2)>2)) {
          x13=127-(GetPotG()/2); y13= 63-(GetPotD()/4);
          Dot(x13,y13);
        }
        LiCol(0,60); Text("Bravo");
        DelMs(1000); 
        Clear();
      }
    case 15: //Ping-pong
   recom:
   while (1){   // rebondit raq 
    PosDir(64,32,4,1); byte cnt=0;
    while(1) { 
      //DelMs(10); //pour ralentir l'aller-retour en 2s
      Step(); 
      y1 = ((256-GetPotG())*3)/16;
      Raq (0,y1);
      y2 = ((256-GetPotD())*3)/16;
      Raq (127,y2);
      Touche();  
      if (touch&1) {dy=-dy;}
      if (touch&2) {goto ko;}
      if (touch&4) {dy=-dy;}
      if (touch&8) {goto ko;}
      if (touch&16) {dx=-dx; cnt++;}
      if (touch&32) {dx=-dx; cnt++;}
      //while (!PousG) ; 
   }
  ko: 
  LiCol(3,50); BigText("KO");LiCol(5,20); Text("PousD recommence"); 
  LiCol(7,30); Text("Score "); LiCol(7,68); Dec8(cnt);
  while(!PousD);
  Clear();
  goto recom;
}
 
    case 14:  // gencar
       Clear();  
       LiCol (0,0); for (byte i= 32; i<48; i++) Car(i);  // Espace, signes 
       LiCol (1,0); for (char i= 48; i<64; i++) Car(i);  // 0 1 2 3 ...
       LiCol (2,0); for (char i= 64; i<80; i++) Car(i);  // @ A B C ... 
       LiCol (3,0); for (char i= 80; i<96; i++) Car(i);  // P Q R S ...
       LiCol (4,0); for (char i= 96; i<112; i++) Car(i); // ` a b c ...
       LiCol (5,0); for (byte i= 112; i<128; i++) Car(i);// p q r s ...
       LiCol (7,80); Sprite(didel);
       while (1);
     
    default:
      LiCol(0,0); Sprite (smile); LiCol(0,100); Sprite (sad); 
      LiCol(2,20); Text("Pas de demo");
      while(1) ; 
  } // end switch case
} // end loop


